/*****************************************************************************
 *
 * UART Communications for PIC24.
 *
 *****************************************************************************
 * FileName:        RS232.c
 * Dependencies:    
 * Processor:       
 * Compiler:       	
 * Linker:          
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Vidyadhar		  30/June/06	     ...	
 
 *****************************************************************************/

#include <p24FJ128GA010.h>


RS232Init()
{

	TRISFbits.TRISF5 = 0;

	U2MODE = 0x0800;
	U2STA = 0x0000;
	U2BRG = 0x19;					//0x26;
	U2MODEbits.UARTEN = 1;
	U2STAbits.UTXEN = 1;

}



GetRS232(int *a,char Len)
{
char i;
char p, q, r, s;

	for(i=0;i<Len;i++)
	{
	  while(!U2STAbits.URXDA);
	  p = U2RXREG;
	  U2TXREG = p;
	  while(!U2STAbits.TRMT);

	  while(!U2STAbits.URXDA);
	  q = U2RXREG;
	  U2TXREG = q;
	  while(!U2STAbits.TRMT);

	  while(!U2STAbits.URXDA);
	  r = U2RXREG;
	  U2TXREG = r;
	  while(!U2STAbits.TRMT);

	  while(!U2STAbits.URXDA);
	  s = U2RXREG;
	  U2TXREG = s;
	  while(!U2STAbits.TRMT);

      if(p>0x40)
		p = p + 0x09;
	  p = p & 0x0f;

      if(q>0x40)
		q = q + 0x09;
	  q = q & 0x0f;

      if(r>0x40)
		r = r + 0x09;
	  r = r & 0x0f;

      if(s>0x40)
		s = s + 0x09;
	  s = s & 0x0f;

	  a[i] = (int) p;
	  a[i] = a[i] << 4;
	  a[i] = a[i] | (int) q;	
	  a[i] = a[i] << 4;
	  a[i] = a[i] | (int) r;	
	  a[i] = a[i] << 4;
	  a[i] = a[i] | (int) s;	
	}
}


PutRS232(char P)
{
    while(!U2STAbits.TRMT);
 	U2TXREG = P;
}



