/*****************************************************************************
 *
 * LCD Driver for PIC24.
 *
 *****************************************************************************
 * FileName:        lcd.h
 * Dependencies:    
 * Processor:       
 * Compiler:       	
 * Linker:          
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 * A simple LCD driver for LCDs interface through the PMP
 * 
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ross Fosler			08/13/04	...	
 
 *****************************************************************************/


extern unsigned int	_uLCDloops;
extern unsigned int _uLCDchar;
extern unsigned int	_uLCDstate;


void LCDProcessEvents(void);


// Query if the LCD is busy processing
#define mLCDIsBusy() 				_uLCDstate

// Init the LCD 
#define mLCDInit() 					_uLCDstate = 2;

// Put a character on the display
#define mLCDPutChar(__lcd_char) 	_uLCDchar = __lcd_char; _uLCDstate = 3;

// Send a generic command
#define mLCDPutCmd(__lcd_cmd)		_uLCDchar = __lcd_cmd; _uLCDstate = 6;

// Clear the display
#define mLCDClear() 				_uLCDstate = 4;

// Home the display
#define mLCDHome() 					_uLCDstate = 5; _uLCDchar = 0;

// Set the mode, dir and shift
#define mLCDEMode(__lcd_cmd)		_uLCDchar = __lcd_cmd | 0x04; _uLCDstate = 6;

// Set the display control, on/off, cursor
#define mLCDCtl(__lcd_cmd)			_uLCDchar = __lcd_cmd | 0x08; _uLCDstate = 6;

// 
#define mLCDShift(__lcd_cmd)		_uLCDchar = __lcd_cmd | 0x10; _uLCDstate = 6;

// Set the interface
#define mLCDFSet(__lcd_cmd)			_uLCDchar = __lcd_cmd | 0x20; _uLCDstate = 6;

// Set the CGRAM address
#define mLCDCDAddr(__lcd_addr)		_uLCDchar = __lcd_addr | 0x40; _uLCDstate = 6;

// Set the DDRAM address
#define mLCDAddr(__lcd_addr) 		_uLCDchar = __lcd_addr | 0x80; _uLCDstate = 6;



