/*****************************************************************************
 *
 * Explorer 16 Development Board Demo Program.
 *
 *****************************************************************************
 * FileName:        main.c
 * Dependencies:    system.h
 * Processor:       PIC24
 * Compiler:       	MPLAB C30
 * Linker:          MPLAB LINK30
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ross Fosler	        XXX         ...	
 * Anton Alkhimenok     10/21/05    ...
 *****************************************************************************/

#include "system.h"

// Setup configuration bits
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx2) 
_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS & FNOSC_PRI )

int main(void)
{
    
	// Setup the LCD
	mLCDInit();

    // Setup the RTCC
    RTCCInit();
	TRISA = 0xFF80;

	TBannerInit();

	while (1) {
		//LCD Processing
		LCDProcessEvents();
       
		//Time Processing
		TBannerProcessEvents();

		if (IFS3bits.RTCIF == 1)		//on RTCC interrupt
		{
			unsigned int i;
			IFS3bits.RTCIF = 0;			//clear RTCC interrupt flag
			LATAbits.LATA4 = 1;			//light LED
			for(i=0; i<60000; i++){
			
			}; 	//delay here for LED
			LATAbits.LATA4 = 0;			//clear LED
		}


    }// End of while(1)...
}// End of main()...
